#include "gamecube.h"
#include <algorithm>
#include <ctime>
#include <vector>
#include <iostream>
#include "gamestate.h"

// -----------------------------------------------------------
// 3D Memory Game – Hauptprogramm mit flexibler Paaranzahl
// -----------------------------------------------------------
int main()
{
    // ✅ Schritt 1: Anzahl der Paare eingeben
    int numPairs;
    std::cout << "Geben Sie die Anzahl der Paare ein (2-10): ";
    std::cin >> numPairs;
    if(numPairs < 2) numPairs = 2;
    if(numPairs > 10) numPairs = 10;

    // Zufall initialisieren
    srand(time(NULL));

    // Fenster und Kamera
    InitWindow(800, 600, "3D Memory Game with Matrix3D Library");
    SetTargetFPS(60);

    Camera3D camera{};
    camera.position = {6.0f, 6.0f, 6.0f};
    camera.target   = {0.0f, 0.0f, 0.0f};
    camera.up       = {0.0f, 1.0f, 0.0f};
    camera.fovy     = 45.0f;
    camera.projection = CAMERA_PERSPECTIVE;

    // Farben generieren (maximal 10 Farben)
    Color baseColors[10] = { RED, GREEN, BLUE, ORANGE, PURPLE, GOLD, PINK, BROWN, SKYBLUE, LIME };
    std::vector<Color> colors(baseColors, baseColors + numPairs);

    // Positionen dynamisch berechnen (Raster 3 Spalten)
    std::vector<Vec3> positions;
    for (int i = 0; i < numPairs*2; ++i)
        positions.push_back({ float(i % 3) * 2 - 2, 0, float(i / 3) * 2 - 2 });

    // Farben doppelt in einen Pool legen und mischen
    std::vector<Color> colorPool;
    for (int i = 0; i < numPairs; i++)
    {
        colorPool.push_back(colors[i]);
        colorPool.push_back(colors[i]);
    }
    // Fisher-Yates Shuffle mit rand()
    for (int i = colorPool.size() - 1; i > 0; --i)
    {
        int j = rand() % (i + 1);
        std::swap(colorPool[i], colorPool[j]);
    }

    // Karten/Würfel erstellen
    std::vector<gamecube> cubes;
    for (int i = 0; i < numPairs*2; i++)
        cubes.emplace_back(positions[i], colorPool[i]);

    gamecube* first  = nullptr;
    gamecube* second = nullptr;
    float flipSpeed = 5.0f;
    bool gameWon = false;
    GameState state = GameState::Idle;


    // -----------------------------------------------------------
    // Hauptspielschleife
    // -----------------------------------------------------------
    while (!WindowShouldClose())
    {
        //Klick-Erkennung
        if (!gameWon && state != GameState::LockInput && state != GameState::CheckingMatch && IsMouseButtonPressed(MOUSE_LEFT_BUTTON))
        {

            Vector2 mouse = GetMousePosition();

            for (auto &c : cubes)
            {
                if (!c.IsFlipped() && !c.IsMatched())
                {
                    Vector2 screenPos = GetWorldToScreen({c.GetPosition().x, c.GetPosition().y, c.GetPosition().z}, camera);

                    if (fabs(mouse.x - screenPos.x) < 40 && fabs(mouse.y - screenPos.y) < 40) {
                        c.FlipForward();
                        state = GameState::OneFlipped;
                    }


                }
            }
        }

        // Animation aller Würfel
        for (auto &c : cubes)
        {
            c.Update(flipSpeed);

            // Sobald ein Würfel vollständig umgedreht ist → merken
            if (c.IsFlipped() && !c.IsMatched())
            {
                if (!first) first = &c;
                else if (!second && &c != first) second = &c;
            }
            if (first && second && first->IsFlipped() && second->IsFlipped()) {
                state = GameState::LockInput;
            }
            if (state == GameState::LockInput) {
                state = GameState::CheckingMatch;
            }
        }

        // Matching-Logik
        if (state == GameState::CheckingMatch && first && second)
        {
            if (first->GetColor().r == second->GetColor().r &&
                first->GetColor().g == second->GetColor().g &&
                first->GetColor().b == second->GetColor().b)
            {
                first->SetMatched(true);
                second->SetMatched(true);
            }
            else
            {
                first->FlipBackward();
                second->FlipBackward();
            }

            first = second = nullptr;
            state = GameState::Idle;
        }

        // Gewinnprüfung
        if (!gameWon)
            gameWon = std::all_of(cubes.begin(), cubes.end(), [](const gamecube &c){ return c.IsMatched(); });

        // -----------------------------------------------------------
        // Zeichnen
        // -----------------------------------------------------------
        BeginDrawing();
        ClearBackground(RAYWHITE);
        BeginMode3D(camera);

        for (auto &c : cubes)
            c.Draw();

        EndMode3D();

        if (gameWon)
            DrawText("Congrats! You found all pairs!", 150, 260, 30, DARKBLUE);
        else
            DrawText("Flip 2 cubes - find matching pairs!", 10, 10, 20, DARKGRAY);



        EndDrawing();
    }

    CloseWindow();
    return 0;
}